/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEB_AUTHN)

#include "JSBasicCredential.h"
#include "JSDOMWrapper.h"
#include "PublicKeyCredential.h"

namespace WebCore {

class JSPublicKeyCredential : public JSBasicCredential {
public:
    using Base = JSBasicCredential;
    using DOMWrapped = PublicKeyCredential;
    static JSPublicKeyCredential* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<PublicKeyCredential>&& impl)
    {
        JSPublicKeyCredential* ptr = new (NotNull, JSC::allocateCell<JSPublicKeyCredential>(globalObject->vm().heap)) JSPublicKeyCredential(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    PublicKeyCredential& wrapped() const
    {
        return static_cast<PublicKeyCredential&>(Base::wrapped());
    }
protected:
    JSPublicKeyCredential(JSC::Structure*, JSDOMGlobalObject&, Ref<PublicKeyCredential>&&);

    void finishCreation(JSC::VM&);
};


template<> struct JSDOMWrapperConverterTraits<PublicKeyCredential> {
    using WrapperClass = JSPublicKeyCredential;
    using ToWrappedReturnType = PublicKeyCredential*;
};

} // namespace WebCore

#endif // ENABLE(WEB_AUTHN)
