/*
 * Copyright (C) 2006-2017 Apple Inc. All rights reserved.
 * Copyright (C) 2009 Kenneth Rohde Christiansen
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 */

//+TELESCOPE_LIB_CHANGES
//5/12/2020
//New platform support, this file is copied from RenderThemeWin.cpp and stub unnecessary funnctions.

#pragma once

#include "RenderTheme.h"

namespace WebCore {

class RenderThemeTelescope final : public RenderTheme {
public:
    friend NeverDestroyed<RenderThemeTelescope>;
#if ENABLE(VIDEO)
	String mediaControlsStyleSheet() override;
	String mediaControlsScript() override;
#endif

	// Returns the repeat interval of the animation for the progress bar.
	Seconds animationRepeatIntervalForProgressBar( RenderProgress & ) const override;
	// Returns the duration of the animation for the progress bar.
	Seconds animationDurationForProgressBar( RenderProgress & ) const override;
	IntRect progressBarRectForBounds( const RenderObject &, const IntRect & ) const override;
	bool paintProgressBar(const RenderObject&, const PaintInfo&, const IntRect&) override;
private:
    void updateCachedSystemFontDescription(CSSValueID systemFontID, FontCascadeDescription&) const final;
};

} // namespace WebCore
//-TELESCOPE_LIB_CHANGES